#include "avr8.h"

extern "C" {
  void __vector_1 (void) __attribute__ ((signal)); 
  void __vector_6 () __attribute__ ((signal));
};

AT90S * at90s = reinterpret_cast<AT90S*>(0x00);

int main(void)
{
  at90s->ddrb   = 0xff;	
  at90s->portb  = 0xff;
  at90s->sreg   = 0x80;     
  at90s->gimsk  = 0x40;     
  at90s->timsk |= 0x80;     
  //at90s->wdtcr  = 0x08;
  at90s->mcucr  = 0x02;     

  while(1);
  return 0;
}

/* IRQ 0 Interrupt Handler */
void __vector_1 (void) 
{
  if(at90s->mcucr == 0x03) {		
    at90s->mcucr  = 0x02;		
    at90s->portb  = 0xff;
    at90s->tccr1b = 0x00;		 
  } else {			
    at90s->mcucr  = 0x03;
    at90s->tccr1b = 0x04;		
  }
}

/* Timer1 Interrupt Handler */
void __vector_6 () {
  at90s->portb = 0xAA;
}
